' Program 1: Compress the training set.
' Program 2: Calculate the movie and user weights.
' Program 3: Run the weight algorithm through the probe.
' 
' Program 1 of 3. This program will compress the training set.

' Training set data will be converted to this form:
' 1) Total ratings for current ID, starting at 0 --
' movies are be reformulated to standard 0-17769 instead of 1-17770.
' 2) Ratings list, each rating containing:
' A 4 byte reformulated Customer ID: 0 to 480188 from 1 to 2649429.
' A 1 byte rating.
' A 2 byte date representation (0 = Oct. 1, 1998).
' Another file containing a list of reformulated-to-regular customer IDs.
' The data will be split into 5 sections:
'
' ratings.dat -> The ratings, sequential.
' userids.dat -> The userids, sequential.
' dates.dat -> The dates, sequential.
' movieend.dat -> The record(s) at which a certain movie(s) switches to another.
' longuserids.dat -> Reformulated-to-regular customer IDs, sequential.
'

#include once "common.bas"

dim as string trainingSetDir = "../download/training_set/"
ratingAmount = 0
dim as integer f, f2
dim as string curFile
dim as integer testExists(userIDMin to userIDMax)
dim as uinteger userAmountOfRatings(0 to userAmount)
dim as uinteger curMovie, curMovieAmount

for i = userIdMin to userIdMax: testExists(i) = -1: next i

print "Starting training set compression."
locate 3,1,0: print "Loading and processing data, part 1..."
j = 0: f2 = 0
for i = 0 to movieAmount-1
 locate 4,1,0: print "Working on movie nominal ID: "; i+1
 tempS1 = ltrim(str(i+1))
 curFile = "mv_" + string(7-len(tempS1), "0") + tempS1 + ".txt"
 f = freefile()
 open trainingsetDir + curFile for input as #f
 tempS2 = space(lof(f))
 get #f, 1, tempS2
 if f2 = 127 then close: f2=0 else f2+=1
 n = 1: m = 0
 do
  n = instr(n, tempS2, ",")+1
  if n = 1 then exit do
  if m = 0 then
   m = instrRev(tempS2, newLine, n)+1
   k = val(trim(mid(tempS2, m, n-m-1)))
   ratingAmount+=1
   if testExists(k) = -1 then testExists(k) = j: j+=1
   userAmountOfRatings(testExists(k)+1) += 1
   m = 1
  else
   m = 0
  end if
 loop
 movieStart(i+1) = ratingAmount

next i
close

saveData(dataDir+"longuserids.dat", testExists())

locate 4,1,0: print space(60)
locate 3,1,0: print "Loading and processing data, part 2..."

redim as uinteger userId(0 to ratingAmount-1)
redim as ushort movieId(0 to ratingAmount-1)
redim as ushort sDate(0 to ratingAmount-1)
redim as ubyte ratingMovie(0 to ratingAmount-1)
redim as ubyte ratingUser(0 to ratingAmount-1)

' Get the ratings per user and resort.
for i = 1 to userAmount
 userAmountOfRatings(i) += userAmountOfRatings(i-1)
 userStart(i) = userAmountOfRatings(i)
next i
'curMovie = -1: curMovieAmount = 0


open "testresults_training.txt" for output as #1

j = 0: f2 = 0
for i = 0 to movieAmount-1
 locate 4,1,0: print "Working on movie nominal ID: "; i+1
 tempS1 = ltrim(str(i+1))
 curFile = "mv_" + string(7-len(tempS1), "0") + tempS1 + ".txt"
 f = 2 'freefile()
 open trainingsetDir + curFile for input as #f
 tempS2 = space(lof(f))
 get #f, 1, tempS2
 close #f
 'if f2 = 127 then close: f2=0 else f2+=1
 n = 1: m = 0
 do
  m = instr(n, tempS2, ",")+1
  if m = 1 then exit do
  n = instrRev(tempS2, newLine, m)+1
  k = val(trim(mid(tempS2, n, m-n-1)))
  userId(j) = testExists(k)
  k = instr(m, tempS2, ",")+1
  ratingMovie(j) = val(trim(mid(tempS2, m, k-m-1)))
  n = instr(k, tempS2, newLine)-1
  tempS1 = trim(mid(tempS2, k, n-k))
  k = dateserial(val(mid(tempS1, 1, 4)), val(mid(tempS1, 6, 7)), val(mid(tempS1, 9, 10))) - minDate
  sDate(j) = k

  k = userId(j)
  m = userAmountOfRatings(k)
  ratingUser(m) = ratingMovie(j)
  movieId(m) = i
  userAmountOfRatings(k)+=1
  j+=1

  if k = 22797 then 
    print #1, "b_";movieid(m)
  end if
 loop
next i
close

locate 3,1,0: print space(60)
locate 4,1,0: print space(60)

locate 3,1,0: print "Writing output to disk..."

saveData(dataDir+"sdates.dat", sDate())
erase sDate, testExists

locate 3,1,0: print space(60)
locate 4,1,0: print space(60)
locate 3,1,0: print "Getting the ratings per user and movie per user..."

dim as uinteger userRatingAmount = 0
redim as uinteger tempMovieId(0): redim as ubyte tempRatingMovie(0)

'Re-sort movieID/ratingMovie.
'dim as uinteger userRatingAmount = 0
for i = 0 to userAmount-1
 userRatingAmount = userStart(i+1)-userStart(i)
 redim as uinteger tempMovieId(0 to userRatingAmount-1)
 redim as ubyte tempRatingMovie(0 to userRatingAmount-1)
 k = 0
 for j = userStart(i) to userStart(i+1)-1
  tempMovieId(k) = movieId(j)
  tempRatingMovie(k) = ratingMovie(j)
  k+= 1
 next j
 qsort @tempMovieId(0), @tempRatingMovie(0), userRatingAmount
 k = 0
 for j = userStart(i) to userStart(i+1)-1
  movieId(j) = tempMovieId(k)
  ratingMovie(j) = tempRatingMovie(k)
  k+= 1
 next j
next i
erase tempMovieId, tempRatingMovie

' Re=sort userId/ratingUser.
dim as uinteger movieRatingAmount = 0
redim as uinteger tempUserId(0): redim as ubyte tempRatingUser(0)

for i = 0 to movieAmount-1
 movieRatingAmount = movieStart(i+1)-movieStart(i)
 redim as uinteger tempUserId(0 to movieRatingAmount-1)
 redim as ubyte tempRatingUser(0 to movieRatingAmount-1)
 k = 0: for j = movieStart(i) to movieStart(i+1)-1
  tempUserId(k) = userId(j)
  tempRatingUser(k) = ratingUser(j)
  k+= 1
 next j
 qsort @tempUserId(0), @tempRatingUser(0), movieRatingAmount, 0
 k = 0: for j = movieStart(i) to movieStart(i+1)-1
  userId(j) = tempUserId(k)
  ratingUser(j) = tempRatingUser(k)
  k+= 1
 next j
next i


locate 3,1,0: print space(60)
locate 4,1,0: print space(60)
locate 3,1,0: print "Writing more output to disk..."

saveData(dataDir+"moviestarts.dat", movieStart())
saveData(dataDir+"ratingmovie.dat", ratingMovie())
saveData(dataDir+"userids.dat", userId())
saveData(dataDir+"ratinguser.dat", ratingUser())
saveData(dataDir+"movieids.dat", movieId())
saveData(dataDir+"userstarts.dat", userStart())

locate 3,1,0: print space(60)
locate 1,1,0: print "Training set compressed! Press any key to exit."
sleep
system
