#include once "common.bas"

dim as single movieSeedPercent1 = .03
dim as single movieSeedPercent2 = .10
dim as single movieSeedPercent3 = .03 ' The percentile to trim to in results.

'Error checking.
if movieSeedPercent3 > movieSeedPercent2 then movieSeedPercent2 = movieSeedPercent3
dim as uinteger moviePercentile1 = movieAmount * movieSeedPercent1
if moviePercentile1 = 0 then moviePercentile1 = movieSeedPercent1
dim as uinteger moviePercentile2 = movieAmount * movieSeedPercent2
if moviePercentile2 = 0 then moviePercentile2 = movieSeedPercent2
dim as uinteger moviePercentile3 = movieAmount * movieSeedPercent3
if moviePercentile3 = 0 then moviePercentile3 = movieSeedPercent3

dim as double curRating, curRatingMovie, curTotalRatings: dim as ubyte success
dim as uinteger curMovie, curUser
dim as uinteger movieCompareMax = 5000 ' Smaller is less accurate but 
dim as ubyte regenerateRMSE = 0        ' generates faster.

print "Loading data..."
loadData dataDir+"ratinguser.dat", ratingMovie()
loadData dataDir+"moviestarts.dat", movieStart()
loadData dataDir+"userids.dat", userId()
loadData dataDir+"ratingmovie.dat", ratingUser()
loadData dataDir+"userstarts.dat", userStart()

loadData dataDir+"movieids.dat", movieId()




'm = binarySearch(userId(), curUser, movieStart(curMovie), movieStart(curMovie+1)-1, success)

' Rank movies by size of ratings, highest first.
' Put these values into "mbs"/"movieByRatingSize".
dim as uinteger movieRatingSize(0 to movieAmount-1)
dim as ushort mbs(0 to movieAmount-1)
'dim as single adjFunction1 (0 to moviePercentile1-1, 0 to moviePercentile2-1)
'dim as byte   adjFunction2 (0 to moviePercentile1-1, 0 to moviePercentile2-1)

print "Sorting movies by size..."
for i = 0 to movieAmount-1
 movieRatingSize(i) = movieStart(i+1)-movieStart(i)
 mbs(i) = i
next i

qsort @movieRatingSize(0), @mbs(0), movieAmount

print "Creating matrix..."
'Get the rating of movie j with movie i's viewers:

open "testresults.txt" for output as #1
dim as single rmse(0 to moviePercentile1*moviePercentile3-1)
dim as ushort rmseMovies(0 to moviePercentile1*moviePercentile3-1)
dim as ushort rmseMoviesPrimary(0 to moviePercentile1-1)
dim as ushort rmseStart(0 to moviePercentile1)

dim as single rmseTemp(0 to moviePercentile2-1)
dim as ushort rmseMoviesTemp(0 to moviePercentile2-1)

dim as uinteger bucketAmount = 30
dim as uinteger bucketAmountTarget = 15
dim as uinteger bucketSizeMax = 500
dim as uinteger bucketGrowthIterations = 30
dim as uinteger ptr moviesInBucketPtr(0 to bucketAmount-1)
dim as ushort moviesInBucketTemp(0 to bucketSizeMax-1)
dim as uinteger curBucketSize(0 to bucketAmount-1)
dim as uinteger rmseCurAmount, curBucketGrowthIteration
dim as uinteger curBucket, curBucketMovie
dim as uinteger curRmseAmount
dim as uinteger curNewMovieLocInBucket
dim as single curUserToBucketScore
redim as single userToBucketScore(0, 0)
redim as ushort moviesInBucket(0)
redim as uinteger moviesInBucketStart(0)
dim as single curScore, userBucketScore
'dim as single userBucketRating(0 to userAmount-1)

regenerateRMSE = 1
if regenerateRMSE = 1 then
 ' In the end, we want to get movieRatingX = customerBucketRatingAverage.
 ' Take X buckets and put a random movie (if it has a rating) in each.
 ' Go through each bucket and keep adding relevant movies.

 ' A:
 ' Create a random sampling of users per iteration and score each bucket.
 ' If the error is too high or iterations too low, then try to add to
 ' the bucket...??
 '
 ' B:
 ' Just do this a certain amount of times.
 '
 ' C: Score users on bucket affinity based on available data.

 loadData dataDir+"rmse.dat", rmse()
 loadData dataDir+"rmseMovies.dat", rmseMovies()
 loadData dataDir+"rmseMoviesPrimary.dat", rmseMoviesprimary()
 loadData dataDir+"rmseStart.dat", rmseStart()

 for i = 0 to bucketAmount-1
  moviesInBucketPtr(i) = callocate(bucketSizeMax, 2)
 next i

 ' Seed first movie.
 for i = 0 to bucketAmount-1
  moviesInBucketPtr(i)[0] = int(rnd*moviePercentile1)
  curBucketSize(i) = 1
'  for j = 1 to bucketSizeMax-2
'   moviesInBucket(i)[j] = BUCKET_EMPTY
  'next j
 next i

 ' Grow the buckets
 for curBucketGrowthIteration = 0 to bucketGrowthIterations-1
  for curBucket = 0 to bucketAmount-1
   if curBucketSize(curBucket) = bucketSizeMax then continue for

   curNewMovieLocInBucket = curBucketSize(curBucket)
   for curBucketMovie = 0 to curBucketSize(curBucket)-1
    ' Get a random movie in from the movie's rmseMovies list.
    curRmseAmount = (rmseStart(curMovie+1)-rmseStart(curMovie))/4
    if curRmseAmount = 0 then continue for
    ' Factor in the rmse data in accepting or rejecting the picked movie.
    ' The rmse data is from 4 (0% chance) to 0 (100% or excellent).
    'if rmse(
    do
     i = int(rnd*curRmseAmount) + rmseStart(curMovie)
     if 4-rmse(i) > rnd*4 then exit do
    loop
    moviesInBucketPtr(curBucket)[curNewMovieLocInBucket] = rmseMovies(i)
    curNewMovieLocInBucket+=1
    if curNewMovieLocInBucket=bucketSizeMax then exit for
   next curBucketMovie
   curBucketSize(curBucket) = curNewMovieLocInBucket
  next curBucket
 next curBucketGrowthIteration

 redim userToBucketScore(0 to userAmount-1, 0 to bucketAmount-1)
 'Now take each user and score him based on the bucket movie list.
 for curBucket = 0 to bucketAmount-1
  curUserToBucketScore = 0
  for curMovie = 0 to curBucketSize(curBucket)-1
   for curUser = 0 to userAmount-1
    k = mbs(moviesInBucketPtr(curBucket)[curMovie])
    m = binarySearch(movieId(), k, userStart(curUser), userStart(curUser+1)-1, success)
    if success then curUserToBucketScore+= ratingUser(m): curTotalRatings+=1
   next curUser
   if curTotalRatings = 0 then
    userToBucketScore(curUser, curBucket) = -1
   else
    userToBucketScore(curUser, curBucket) = curUserToBucketScore/curTotalRatings
   end if
  next curMovie
 next curBucket
 
 ' Now convert movies in bucket to a sorted list.
 i = 0
 for curBucket = 0 to bucketAmount-1
  i+= curBucketSize(curBucket)
 next curBucket
 redim as ushort moviesInBucket(0 to i-1)
 redim as uinteger moviesInBucketStart(0 to bucketAmount)
 i = 0
 for curBucket = 0 to bucketAmount-1
  k = 0
  redim moviesInBucketTemp(0 to curBucketSize(curBucket)-1)
  moviesInBucketStart(curBucket) = i
  for curMovie = 0 to curBucketSize(curBucket)-1
   moviesInBucket(i) = mbs(moviesInBucketPtr(curBucket)[curMovie])
   moviesInBucketTemp(k) = moviesInBucket(i)
   i+=1: k+=1
  next curMovie
  qsort @moviesInBucketTemp(0), curBucketSize(curBucket)
  k = 0: j = moviesInBucketStart(curBucket)
  for curMovie = 0 to curBucketSize(curBucket)-1
   moviesInBucket(j) = movieInBucketTemp(k)
   k+=1: j+=1
  next curMovie
 next curBucket
 moviesInBucketStart(bucketAmount) = i

 saveData dataDir+"usertobucketscore.dat", userToBucketScore()
 saveData dataDir+"moviesinbucket.dat", moviesInBucket()
 saveData dataDir+"moviesinbucketstarts.dat", moviesInBucketStart()

elseif regenerateRMSE = 2 then

 redim userToBucketScore(0 to userAmount-1, 0 to bucketAmount-1)
 loadData dataDir+"usertobucketscore.dat", userToBucketScore()

 redim moviesInBucketStart(0 to bucketAmount)
 loadData dataDir+"moviesinbucketstarts.dat", moviesInBucketStart()
 i = moviesInBucketStart(bucketAmount)

 redim as ushort moviesInBucket(0 to i-1)
 loadData dataDir+"moviesinbucket.dat", moviesInBucket()
 
 open "qualifying.txt" for input as #2
 open "results.txt" for output as #3
 do
  if eof(2) then exit do
  line input #2, tempS1
  n = instr(tempS1, ":")
  if n then
   curMovie = val( left(tempS1, len(tempS1)-1) )
   curMovie-=1
   'Convert curMovie to inverse of mbs().
   print #3, tempS1
  end if

  if tempS1 = "" then continue do
  n = instr(tempS1, ",")
  if n then curUser = val( left(tempS1, n-1 )
  'Convert curUser to normalized value.
  curScore = 0: curTotalRatings = 0
  for curBucket = 0 to bucketAmount
   ' a) If the bucket has curMovie then add this bucket to the user score.
   ' find the movie in the bucket.. if nothing there, continue.
   ' get userToBucketScore

    m = binarySearch(moviesInBucket(), curMovie, moviesInBucketStart(curBucket), moviesInBucketStart(curBucket+1)-1, success)
    if success then curRating+= userToBucketScore(curUser, m): curTotalRatings+=1

  next curBucket
  if curTotalRatings <> 0 then
   curScore = curScore / curTotalRatings
  else
   curScore = 4
  end if

  curScore = int(curScore*1000)/1000
  tempS2 = str(curScore)
  print #3, tempS2
 loop

 close
' for i = 100 to moviePercentile1-1
' print #1, rmseMoviesPrimary(i)
' for j = rmseStart(i) to rmseStart(i+1)-1
  'if rmse(j)<>-1 then
'   print #1,rmse(j), rmseMovies(j)
  'end if
 'next j

' saveData dataDir+"pots.dat", potData()
' print "Done."
' sleep
' system
'next i
'sleep
'system
else
 o = 0
 for i = 0 to moviePercentile1-1
  locate 1,1: print i; "           "
  movieAmount = movieStart(mbs(i)+1) - movieStart(mbs(i))
  for j = 0 to moviePercentile2-1
   if i = j then continue for
   curRating = 0: curTotalRatings = 0: n = 1
   for k = movieStart(mbs(i)) to movieStart(mbs(i)+1)-1
    curRatingMovie = ratingMovie(k)
    v = userId(k)
    m = binarySearch(movieId(), mbs(j), userStart(v), userStart(v+1)-1, success)
    if success then curRating+= (curRatingMovie-ratingUser(m))^2: curTotalRatings+=1
    if n = movieCompareMax then exit for else n+=1  
   next k
   rmseTemp(j) = -1
   if curTotalRatings <> 0 then
    if curTotalRatings / n > .125 then
     rmseTemp(j) = sqr(curRating/curTotalRatings)
     rmseMoviesTemp(j) = j
    end if
   end if
  next j
  qsort @rmseTemp(0), @rmseMoviesTemp(0), moviePercentile2
  rmseStart(i) = o
  for j = 0 to moviePercentile3-1
   if rmseTemp(j) <> -1 then
    rmse(o) = rmseTemp(j)
    rmseMovies(o) = rmseMoviesTemp(j)
    o+=1
   end if
  next j
  rmseMoviesPrimary(i) = mbs(i)
 next i
 rmseStart(i) = o
 redim preserve rmse(0 to o-1)
 redim preserve rmseMovies(0 to o-1)
 saveData dataDir+"rmse.dat", rmse()
 saveData dataDir+"rmseMovies.dat", rmseMovies()
 saveData dataDir+"rmseMoviesPrimary.dat", rmseMoviesPrimary()
 saveData dataDir+"rmseStart.dat", rmseStart()
end if


print "Done!"
sleep
system
'open dataDir+"userids.dat" for binary as #2
'get #1, 1, userId()
'close
'for i = 